# tiki_articles
# 

drop table if exists tiki_kb_assignments;
create table tiki_kb_assignments (

	assignmentID integer(12) not null auto_increment,
	doctype integer(12),
	category1 integer(12),
	category2 integer(12),
	keywords text,
	docID integer(8),
	wikiname varchar(160),

	primary key(assignmentID)
);

INSERT INTO tiki_kb_assignments (assignmentid,doctype,category1,category2,keywords,docid,wikiname) VALUES
	(1000, 1, 1, 4, "first, doco", 1, '');

INSERT INTO tiki_kb_assignments (assignmentid,doctype,category1,category2,keywords,docid,wikiname) VALUES
	(1001, 2, 2, 5, "second, thing", 2, '');

INSERT INTO tiki_kb_assignments (assignmentid,doctype,category1,category2,keywords,docid,wikiname) VALUES
	(1002, 3, 2, 5, "white, thing", 2, '');
	
INSERT INTO tiki_kb_assignments (assignmentid,doctype,category1,category2,keywords,docid,wikiname) VALUES
	(1003, 4, 3, 6, "wiki thing", 0, 'MyFirstPage');
	


drop table if exists tiki_kb_categories;
create table tiki_kb_categories (

	categoryID integer(12) not null auto_increment,
	level integer(12),
	categoryname text,
	
	primary key(categoryID)
);

INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (1, 1, "cat1item1");
INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (2, 1, "cat1item2");
INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (3, 1, "cat1item3");
INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (4, 2, "cat2item1");
INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (5, 2, "cat2item2");
INSERT INTO tiki_kb_categories (categoryID, level, categoryname) VALUES (6, 2, "cat2item3");

drop table if exists tiki_kb_doctypes;
create table tiki_kb_doctypes (
	typeid integer(12) not null auto_increment,
	doctype text,
	displayname text,
	
	primary key(typeid)
);

INSERT INTO tiki_kb_doctypes (typeid, doctype, displayname) VALUES (1, "article", "Infodoc");
INSERT INTO tiki_kb_doctypes (typeid, doctype, displayname) VALUES (2, "faq", "FAQ");
INSERT INTO tiki_kb_doctypes (typeid, doctype, displayname) VALUES (3, "article", "White Paper");
INSERT INTO tiki_kb_doctypes (typeid, doctype, displayname) VALUES (4, "wiki", "Scribble");


# Native KB Documents (a bit like articles, only simpler)

drop table if exists tiki_kb_documents;
create table tiki_kb_documents (
	docID integer(8) not null auto_increment,
	title varchar(80),
	author varchar(60),
	date integer(14),
	description text,
  	body text,
  	reads integer(14),
  	authflag char(1),
  	
  	primary key(docID)
);

# Native KB FAQs (very much like the normal Tiki FAQs)
DROP TABLE IF EXISTS tiki_kbfaqs;
create table tiki_kbfaqs(
  faqID integer(10) not null auto_increment,
  title varchar(200),
  description text,
  created integer(14),
  questions integer(5),
  hits integer(8),
  canSuggest char(1),
  primary key(faqId)
);

DROP TABLE IF EXISTS tiki_kbfaq_questions;
create table tiki_kbfaq_questions(
  questionId integer(10) not null auto_increment,
  faqId integer(10),
  position integer(4),
  question text,
  answer text,
  primary key(questionId)
);

DROP TABLE IF EXISTS tiki_kb_suggested_faq_questions;
create table tiki_kb_suggested_faq_questions (
   sfqId integer(10) not null auto_increment,
   faqId integer(10) not null,
   question text,
   answer text,
   created integer(14),
   user varchar(200),
   primary key(sfqId)
);


#insert into users_permissions(permName,type,permDesc) values('tiki_p_view_kb','kb','Can view/search the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_browse_kb','kb','Can browse the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_edit_kb','kb','Can edit docs in the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_create_kb','kb','Can create docs in the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_delete_kb','kb','Can delete docs in the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_admin_kb','kb','Can administer the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_cat_kb','kb','Can create categories in the KB');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_auth_kb_docs','kb','Can authorise publication of KB documents');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_auth_kb_faqs','kb','Can authorise publication of KB FAQs');
#insert into users_permissions(permName,type,permDesc) values('tiki_p_kb_approve_suggested','kb','Can authorise use of KB FAQ suggested questions');

UPDATE users_permissions set level='editors' where permName='tiki_p_view_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_browse_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_edit_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_create_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_delete_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_admin_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_cat_kb';
UPDATE users_permissions set level='editors' where permName='tiki_p_auth_kb_docs';
UPDATE users_permissions set level='editors' where permName='tiki_p_auth_kb_faqs';

