<?
require_once('tiki-setup.php');
require_once('lib/kb/kblib.php');


// Now check permissions to access this page
if((!isset($tiki_p_view_kb)) || ($tiki_p_view_kb != 'y')) {
  $smarty->assign('msg',tra("Permission denied you cannot view KB pages"));
  $smarty->display("styles/$style_base/error.tpl");
  die;  
}


$kblib = new KBLib($dbTiki,$tikilib);

// There are two ways we could output the default page, one
// way is if we're just requested, the other is if the page
// the user asked for does not exist. If that's the case, then
// we have an extra variable assigned (called "message") that
// says "doc does not exist". Either way, the page is 99% the same.
function default_output_page()
{
	global $kblib;
	global $smarty;
	global $style_base;
	global $tikilib;
	
	$areas["title"]=0;
	$areas["desc"]=0;
	$areas["body"]=0;
	$areas["keywords"]=0;
	
	$doctypes_list=$kblib->get_available_doctypes();
	
	$areas_list=$kblib->get_supported_areas();
	
	$go=0;
	$areas_reqd=array();
	$areas_template=array();
	foreach ($areas_list as $item)
	{
		$temp=array();
		$temp["name"]=$item;
		$temp["var"]="a".substr($item,0,2);
		if(isset($_REQUEST[$temp["var"]]))
		{
			$areas_reqd[$item]=1;
			$temp["checked"]="CHECKED";
			$go=1;
		}
		$areas_template[]=$temp;
	}
	
	if($go==0)
	{
		// No areas have been set, so set them all
		$areas_template=array();
		foreach ($areas_list as $item)
		{
			$temp="a".substr($item,0,2);
			$areas_template[]=array("name" => $item, "checked" => "CHECKED", "var" => $temp);
			$areas_reqd[$item]=1;
			$smarty->assign("type_".$item."checked","CHECKED");
		}
	}
	$smarty->assign_by_ref('areas',$areas_template);
	
	$go=0;
	$doctypes_reqd=array();
	$doctypes_template=array();
	foreach ($doctypes_list as $item)
	{
		$temp=array();
		$temp["name"]=$item;
		$temp["var"]="t".substr($item,0,4);
		if(isset($_REQUEST[$temp["var"]]))
		{
			$doctypes_reqd[$item]=1;
			$temp["checked"]="CHECKED";
			$go=1;
		}
		$doctypes_template[]=$temp;
	}
	
	if($go==0)
	{
		// No doc types have been set, so set them all
		$doctypes_template=array();
		foreach ($doctypes_list as $item)
		{
			$temp="t".substr($item,0,4);
			$doctypes_template[]=array("name" => $item, "checked" => "CHECKED", "var" => $temp);
			$doctypes_reqd[$item]=1;
			$smarty->assign("type_".$item."checked","CHECKED");
		}
	}
	$smarty->assign_by_ref('doctypes',$doctypes_template);
			

	if(isset($_REQUEST["terms"]))
	{
		// essentially, we need to do a search...
		// and set everything to say we've done one
		$smarty->assign('terms',$_REQUEST["terms"]);
		$smarty->assign('performed_search','yes');
		
		// Sanitise the search terms to avoid SQL injection issues
		// NOT IMPLEMENTED
		$terms=$_REQUEST["terms"];
		
		// do searches...
		$maxRecords=10;
		$offset=0;
		
		$results=$kblib->find_docs($terms,$areas_reqd,$doctypes_reqd,$offset,$maxRecords);
		
		$smarty->assign_by_ref('results',$results);
		
	}

	
	
	
	//$cats = $kblib->list_docs();
	//$smarty->assign_by_ref('cats',$cats);
	$smarty->assign('mid','tiki-kb.tpl');
	$smarty->display("styles/$style_base/tiki.tpl");
	die;
}



if(!isset($_REQUEST["docId"])) {

	default_output_page();
	
} else {

	// If the user has suggested a question, then a couple of extra things
	// will be set. We need to insert the suggested question before we do
	// anything else so that the rest of the page includes the newly suggested
	// question
	
	if((isset($_REQUEST['suggested_question'])) && ($_REQUEST['suggested_question'] != ""))
	{
		// handle suggested question
		$kblib->add_suggested_faq_question($_REQUEST['docId'],$_REQUEST['suggested_question'],$_REQUEST['suggested_answer'],"user");
	}

	$docid = $kblib->sanitise_input($_REQUEST["docId"]);
	
	$attribs=$kblib->get_assignment_row($_REQUEST["docId"]);
	
	if(!isset($attribs['docID']))
	{
		# Document does not exist
		$smarty->assign('message',"Document \"$docid\" does not exist.");
		default_output_page();
	}
	
	$smarty->assign_by_ref('attribs',$attribs);
	
	$smarty->assign('style_base',$style_base);
	
	switch ($attribs['doctype'])
	{
		case 'article':
			// Articles ------------------------------------------
			  $tikilib->add_article_hit($attribs['docID']);
			  
			  // This code stolen from tiki-read_article.php
			  
  $smarty->assign('articleId',$attribs['docID']);
  $article_data = $tikilib->get_article($attribs['docID']);
  if(!$article_data) {
    $smarty->assign('msg',tra("Article not found"));
    $smarty->display("styles/$style_base/error.tpl");
    die;  
  }

  if($userlib->object_has_one_permission($article_data["topicId"],'topic')) {
    if(!$userlib->object_has_permission($user,$article_data["topicId"],'topic','tiki_p_topic_read')) {
      $smarty->assign('msg',tra("Permision denied"));
      $smarty->display("styles/$style_base/error.tpl");
      die;  
    }
  }

  
  
  if( ($article_data["publishDate"]>date("U")) && ($tiki_p_admin != 'y') ){
    $smarty->assign('msg',tra("Article is not published yet"));
    $smarty->display("styles/$style_base/error.tpl");
    die;  
  }
  $smarty->assign('title',$article_data["title"]);
  $smarty->assign('authorName',$article_data["authorName"]);
  $smarty->assign('topicId',$article_data["topicId"]);
  $smarty->assign('type',$article_data["type"]);
  $smarty->assign('rating',$article_data["rating"]);
  $smarty->assign('entrating',$article_data["entrating"]);
  $smarty->assign('useImage',$article_data["useImage"]);
  $smarty->assign('image_name',$article_data["image_name"]);
  $smarty->assign('image_type',$article_data["image_type"]);
  $smarty->assign('image_size',$article_data["image_size"]);
  $smarty->assign('image_x',$article_data["image_x"]);
  $smarty->assign('image_y',$article_data["image_y"]);
  $smarty->assign('image_data',urlencode($article_data["image_data"]));
  $smarty->assign('reads',$article_data["reads"]);
  $smarty->assign('size',$article_data["size"]);
  if(strlen($article_data["image_data"])>0) {
    $smarty->assign('hasImage','y');
    $hasImage='y';
  }
  $smarty->assign('heading',$article_data["heading"]);
  $smarty->assign('body',$article_data["body"]);
  $smarty->assign('publishDate',$article_data["publishDate"]);
  $smarty->assign('edit_data','y');
  
  $body = $article_data["body"];
  $heading = $article_data["heading"]; 
  $smarty->assign('parsed_body',$tikilib->parse_data($body));
  $smarty->assign('parsed_heading',$tikilib->parse_data($heading));

			$smarty->assign('operation',"article");
			$smarty->assign('mid','tiki-kb.tpl');
			// ---------------------------------------------------
			break;
		case 'faq':
			// FAQs ----------------------------------------------
			
			// This code stolen from tiki-view_faq.php
			
include_once('lib/faqs/faqlib.php');
$faqlib->add_faq_hit($attribs['docID']);

$smarty->assign('faqId',$attribs['docID']);
$faq_info = $tikilib->get_faq($attribs['docID']);
$smarty->assign('faq_info',$faq_info);

if(isset($_REQUEST["find"])) {
  $find = $_REQUEST["find"];  
} else {
  $find = ''; 
}
$smarty->assign('find',$find);

$channels = $faqlib->list_faq_questions($attribs['docID'],0,-1,'question_asc',$find);


$smarty->assign_by_ref('channels',$channels["data"]);

if(isset($_REQUEST["sugg"])) {
  if($tiki_p_suggest_faq == 'y')  {
    $faqlib->add_suggested_faq_question($attribs['docID'],$_REQUEST["suggested_question"],$_REQUEST["suggested_answer"],$user);
  }
}

$suggested = $faqlib->list_suggested_questions(0,-1,'created_desc','');
$smarty->assign_by_ref('suggested',$suggested["data"]);


			$smarty->assign('operation',"faq");
			$smarty->assign('mid','tiki-kb.tpl');
			// ---------------------------------------------------
			break;
			
		case "wiki":
		
			// setup the things the code below needs
			$_REQUEST["page"]=$attribs['wikiname'];
		
			// This code stolen from tiki-index.php
		
include_once('lib/structures/structlib.php');

include_once('lib/wiki/wikilib.php');


if($feature_wiki != 'y') {
  $smarty->assign('msg',tra("This feature is disabled"));
  $smarty->display("styles/$style_base/error.tpl");
  die;  
}

//print($GLOBALS["HTTP_REFERER"]);

// Create the HomePage if it doesn't exist
if(!$tikilib->page_exists("HomePage")) {
  $tikilib->create_page("HomePage",0,'',date("U"),'Tiki initialization'); 
}

if(!isset($_SESSION["thedate"])) {
  $thedate = date("U");
} else {
  $thedate = $_SESSION["thedate"];
}

// Get the page from the request var or default it to HomePage
if(!isset($_REQUEST["page"])) {
  $_REQUEST["page"]=$wikiHomePage;
  $page = $wikiHomePage;
  $smarty->assign('page',$wikiHomePage); 
} else {
  $page = $_REQUEST["page"];
  $smarty->assign_by_ref('page',$_REQUEST["page"]); 
}
if(!$tikilib->page_exists($wikiHomePage)) {
  $tikilib->create_page($wikiHomePage,0,'',date("U"),'Tiki initialization'); 
}



require_once('tiki-pagesetup.php');




// If the page doesn't exist then display an error
if(!$tikilib->page_exists($page)) {
  $smarty->assign('msg',tra("Page cannot be found"));
  $smarty->display("styles/$style_base/error.tpl");
  die;
}


// Now check permissions to access this page
if($tiki_p_view != 'y') {
  $smarty->assign('msg',tra("Permission denied you cannot view this page"));
  $smarty->display("styles/$style_base/error.tpl");
  die;  
}

// BreadCrumbNavigation here
// Get the number of pages from the default or userPreferences
// Remember to reverse the array when posting the array
$anonpref = $tikilib->get_preference('userbreadCrumb',4);
if($user) {
  $userbreadCrumb = $tikilib->get_user_preference($user,'userbreadCrumb',$anonpref);
} else {
  $userbreadCrumb = $anonpref;
}
if(!isset($_SESSION["breadCrumb"])) {
  $_SESSION["breadCrumb"]=Array();
}
if(!in_array($page,$_SESSION["breadCrumb"])) {
  if(count($_SESSION["breadCrumb"])>$userbreadCrumb) {
    array_shift($_SESSION["breadCrumb"]);
  } 
  array_push($_SESSION["breadCrumb"],$page);
} else {
  // If the page is in the array move to the last position
  $pos = array_search($page, $_SESSION["breadCrumb"]);
  unset($_SESSION["breadCrumb"][$pos]);
  array_push($_SESSION["breadCrumb"],$page);
}
//print_r($_SESSION["breadCrumb"]);


// Now increment page hits since we are visiting this page
$tikilib->add_hit($page);

// Get page data
$info = $tikilib->get_page_info($page);

$smarty->assign('page_user',$info['user']);

// Check if we have to perform an action for this page
// for example lock/unlock
if( 
    ($tiki_p_admin_wiki == 'y') 
    || 
    ($user and ($tiki_p_lock == 'y') and ($feature_wiki_usrlock == 'y'))
   ) {
if(isset($_REQUEST["action"])) {
  if($_REQUEST["action"]=='lock') {
    $tikilib->lock_page($page);
  }  
}
}

if( 
    ($tiki_p_admin_wiki == 'y') 
    || 
    ($user and ($user == $info['user']) and ($tiki_p_lock == 'y') and ($feature_wiki_usrlock == 'y'))
   ) {
if(isset($_REQUEST["action"])) {
  if ($_REQUEST["action"]=='unlock') {
    $tikilib->unlock_page($page);
  }  
}
}


// Save to notepad if user wants to
if($user 
    && $feature_wiki_notepad == 'y' 
	&& $tiki_p_notepad == 'y' 
	&& $feature_notepad == 'y' 
	&& isset($_REQUEST['savenotepad'])) {
  include_once('lib/notepad/notepadlib.php');	
  $notepadlib->replace_note($user,0,$_REQUEST['page'],$info['data']);
}

// Verify lock status
if($info["flag"] == 'L') {
  $smarty->assign('lock',true);  
} else {
  $smarty->assign('lock',false);
}

// If not locked and last version is user version then can undo
$smarty->assign('canundo','n');	
if($info["flag"]!='L' && ( ($tiki_p_edit == 'y' && $info["user"]==$user)||($tiki_p_remove=='y') )) {
   $smarty->assign('canundo','y');	
}
if($tiki_p_admin_wiki == 'y') {
  $smarty->assign('canundo','y');		
}

// Process an undo here
if(isset($_REQUEST["undo"])) {
if($tiki_p_admin_wiki == 'y' || ($info["flag"]!='L' && ( ($tiki_p_edit == 'y' && $info["user"]==$user)||($tiki_p_remove=='y')) )) {
  // Remove the last version	
  $tikilib->remove_last_version($page);
  // If page was deleted then re-create
  if(!$tikilib->page_exists($page)) {
    $tikilib->create_page($page,0,'',date("U"),'Tiki initialization'); 
  }
  // Restore page information
  $info = $tikilib->get_page_info($page);  	
}
}

$slides = split("-=[^=]+=-",$info["data"]);
if(count($slides)>1) {
	$smarty->assign('show_slideshow','y');
} else {
	$smarty->assign('show_slideshow','n');
}

if(isset($_REQUEST['refresh'])) {
  $tikilib->invalidate_cache($page);	
}
// Here's where the data is parsed
// if using cache
//
// get cache information
// if cache is valid then pdata is cache
// else
// pdata is parse_data 
//   if using cache then update the cache
// assign_by_ref
$smarty->assign('cached_page','n');
if($wiki_cache>0) {
 $cache_info = $wikilib->get_cache_info($page);
 $now = date('U');
 if($cache_info['cache_timestamp']+$wiki_cache > $now) {
   $pdata = $cache_info['cache'];
   $smarty->assign('cached_page','y');
 } else {
   $pdata = $tikilib->parse_data($info["data"]);
   $wikilib->update_cache($page,$pdata);
 }
} else {
 $pdata = $tikilib->parse_data($info["data"]);
}
$smarty->assign_by_ref('parsed',$pdata);

//$smarty->assign_by_ref('lastModif',date("l d of F, Y  [H:i:s]",$info["lastModif"]));
$smarty->assign_by_ref('lastModif',$info["lastModif"]);
if(empty($info["user"])) {
  $info["user"]='anonymous';  
}
$smarty->assign_by_ref('lastUser',$info["user"]);
$smarty->assign_by_ref('description',$info["description"]);
/*
// force enable wiki comments (for development)
$feature_wiki_comments = 'y';
$smarty->assign('feature_wiki_comments','y');
*/

// Comments engine!
if($feature_wiki_comments == 'y') {
  $comments_per_page = $wiki_comments_per_page;
  $comments_default_ordering = $wiki_comments_default_ordering;
  $comments_vars=Array('page');
  $comments_prefix_var='wiki page';
  $comments_object_var='page';
  include_once("comments.php");
}

$section='wiki';
include_once('tiki-section_options.php');



if($feature_wiki_attachments == 'y') {
  if(isset($_REQUEST["removeattach"])) {
    $owner = $wikilib->get_attachment_owner($_REQUEST["removeattach"]);
    if( ($user && ($owner == $user) ) || ($tiki_p_wiki_admin_attachments == 'y') ) {
      $wikilib->remove_wiki_attachment($_REQUEST["removeattach"]);
    }
  }
  if(isset($_REQUEST["attach"]) && ($tiki_p_wiki_admin_attachments == 'y' || $tiki_p_wiki_attach_files == 'y')) {
    // Process an attachment here
    if(isset($_FILES['userfile1'])&&is_uploaded_file($_FILES['userfile1']['tmp_name'])) {
      $fp = fopen($_FILES['userfile1']['tmp_name'],"rb");
      $data = '';
      $fhash='';
      if($w_use_db == 'n') {
        $fhash = md5($name = $_FILES['userfile1']['name']);    
        $fw = fopen($w_use_dir.$fhash,"w");
        if(!$fw) {
          $smarty->assign('msg',tra('Cannot write to this file:').$fhash);
          $smarty->display("styles/$style_base/error.tpl");
          die;  
        }
      }
      while(!feof($fp)) {
        if($w_use_db == 'y') {
          $data .= fread($fp,8192*16);
        } else {
          $data = fread($fp,8192*16);
          fwrite($fw,$data);
        }
      }
      fclose($fp);
      if($w_use_db == 'n') {
        fclose($fw);
        $data='';
      }
      $size = $_FILES['userfile1']['size'];
      $name = $_FILES['userfile1']['name'];
      $type = $_FILES['userfile1']['type'];
      $wikilib->wiki_attach_file($page,$name,$type,$size, $data, $_REQUEST["attach_comment"], $user,$fhash);
    }
  }

  $atts = $wikilib->list_wiki_attachments($page,0,-1,'created_desc','');
  $smarty->assign('atts',$atts["data"]);
}


$smarty->assign('footnote','');
$smarty->assign('has_footnote','n');
if($feature_wiki_footnotes == 'y') {
  if($user) {
    $x = $wikilib->get_footnote($user,$page);
    $footnote=$wikilib->get_footnote($user,$page);
    $smarty->assign('footnote',$tikilib->parse_data($footnote));
    if($footnote) $smarty->assign('has_footnote','y');
  }
}

$smarty->assign('wiki_extras','y');
$smarty->assign('structure','n');   
if($structlib->page_is_in_structure($page)) {   
	$smarty->assign('structure','y');   
	$prev=$structlib->get_prev_page($page);   
	$next=$structlib->get_next_page($page);   
	$struct=$structlib->get_structure($page);   
	$smarty->assign('struct_next',$next);   
	$smarty->assign('struct_prev',$prev);   
	$smarty->assign('struct_struct',$struct);   
} 

if($feature_theme_control == 'y') {
	$cat_type='wiki page';
	$cat_objid = $_REQUEST["page"];
	include('tiki-tc.php');
}


// Display the Index Template
$smarty->assign('dblclickedit','y');
$smarty->assign('show_page_bar','y');
		
		
		
			// one not set above
			$smarty->assign('reads',$info['hits']);
		
			$smarty->assign('operation',"wiki");
			$smarty->assign('mid','tiki-kb.tpl');
		
		
		
			break;
		case "kbdoc":
			// we already have $attribs, and it's been checked to make sure it's okay.
			$document=$kblib->get_kb_document($attribs['docID']);
			
			if($document['authflag'] != 'y')
			{
				// If the user doesn't have auth_kb_docs permission, then
				// they get an error. Otherwise, we set a variable that gets used
				// in the template.
				
				if((!isset($tiki_p_auth_kb_docs)) || ($tiki_p_auth_kb_docs != 'y')) {
					$smarty->assign('msg',tra("Document ".$_REQUEST["docId"]." has not been published."));
					$smarty->display("styles/$style_base/error.tpl");
					die;
				}
				else
					$smarty->assign('notpublished','true');
			}
			
			$smarty->assign_by_ref('document',$document);
			$smarty->assign('operation',"kbdoc");
			$smarty->assign('mid','tiki-kb.tpl');
			
			break;
		case "kbfaq":
			// This is very similar to Tiki FAQs, except it uses the KBlib
			// for everything instead of tikilib/faqlib.
			$kblib->add_faq_hit($attribs['docID']);

			$smarty->assign('faqId',$attribs['docID']);
			$faq_info = $kblib->get_kb_faq($attribs['docID']);
			if($faq_info == false)
			{
				$smarty->assign('msg',tra("Document ".$_REQUEST['docId']." could not be displayed"));
				$smarty->display("styles/$style_base/error.tpl");
				die;
			}
			$smarty->assign('document',$faq_info);

			if(isset($_REQUEST["find"])) {
			  $find = $_REQUEST["find"];  
			} else {
			  $find = ''; 
			}
			$smarty->assign('find',$find);

			$channels = $kblib->list_faq_questions($attribs['docID'],0,-1,'question_asc',$find);

			$smarty->assign_by_ref('channels',$channels["data"]);

			//if(isset($_REQUEST["sugg"])) {
			//  if($tiki_p_suggest_faq == 'y')  {
			//    $kblib->add_suggested_faq_question($attribs['docID'],$_REQUEST["suggested_question"],$_REQUEST["suggested_answer"],$user);
			//  }
			//}

			$suggested = $kblib->list_suggested_questions(0,-1,'created_desc','');
			$smarty->assign_by_ref('suggested',$suggested["data"]);

			$smarty->assign('operation',"kbfaq");
			$smarty->assign('mid','tiki-kb.tpl');
			break;
			
		default:
			default_output_page();
			break;
	}
} 


$smarty->display("styles/$style_base/tiki.tpl");
?>