<?

// tiki-kb_admin.php
// Administer the KB. This page allows the administrator
// to create/edit document types and categories



require_once('tiki-setup.php');
require_once('lib/kb/kblib.php');


// Now check permissions to access this page
if((!isset($tiki_p_admin_kb)) || ($tiki_p_admin_kb != 'y')) {
  $smarty->assign('msg',tra("Permission denied you cannot administer the KB"));
  $smarty->display("styles/$style_base/error.tpl");
  die;  
}

$kblib = new KBLib($dbTiki,$tikilib);

$supported_types=$kblib->get_supported_doctypes(NULL);
$smarty->assign('supported_doctypes',$supported_types);
	
$doctypes_table=$kblib->get_doctypes_table();
$smarty->assign('available_doctypes',$doctypes_table);

$category1=$kblib->get_categories(1);
$category2=$kblib->get_categories(2);

$smarty->assign_by_ref('category1',$category1);
$smarty->assign_by_ref('category2',$category2);


if((isset($_REQUEST['doctype'])) && (isset($_REQUEST['edit'])) )
{
	// we're editing/deleting a doctype
	
	// See if we're deleting...
	if((isset($_REQUEST['delete'])) && ($_REQUEST['delete'] == "yes"))
	{
		// attempt to delete this doctype
		
		$name=$kblib->delete_doctype($_REQUEST['doctype']);
		
		if($name)
		{
		
			$smarty->assign('message',"DocType '$name' has been deleted");
			# Reload this table because we've just changed it!
			$doctypes_table=$kblib->get_doctypes_table();
			$smarty->assign('available_doctypes',$doctypes_table);
		}
		else
		{
			$smarty->assign('message',"Failed to delete the DocType. Do documents of this type exist?");
		}
		
	}
	else
	{
		// Not deleting, so we're editing or saving a new entry
	
		// First, see if we need to save something.
	
		if((isset($_REQUEST['newname'])) && ($_REQUEST['newname'] != ""))
		{
			// Looks like we're supposed to save something out...
			if(!$kblib->change_doctype_name($_REQUEST['doctype'],$_REQUEST['newname']))
			{
				// the change failed
				$smarty->assign('message',"Failed to change DocType display name");
			}
		}
	
		// Now get the right stuff out for display
		
		$row=$kblib->get_doctype_by_id($_REQUEST['doctype']);
		
		if(isset($row['displayname']))
		{
			$smarty->assign('operation_mode',"edit_doctype");
			
			$smarty->assign('displayname_to_edit',$row["displayname"]);
			$smarty->assign('doctype_to_edit',$_REQUEST['doctype']);
		
			$doctypes_table=$kblib->get_doctypes_table();
			$smarty->assign('available_doctypes',$doctypes_table);
		}
		else
			$smarty->assign('message',"There was a problem reading the doctype information for editing");
	}
}
elseif(isset($_REQUEST['update_types']))
{
	// we're updating the document types
	$go=1;
	while($go>0)
	{
		$name="$go"."_type";
		if(isset($_REQUEST[$name]))
		{
	
			if(!$kblib->change_doctype($_REQUEST[$name],$go))
			{
				// the change failed
				$smarty->assign('message',"Failed to change DocType");
				break;
			}
		}
		else
		{
			break;
		}
		$go++;
	}
	
	// check to see if we need to add a new doctype
	if((isset($_REQUEST['newname'])) && (isset($_REQUEST['newname_type'])) && ($_REQUEST['newname'] != ""))
	{
		// looks like we're adding...
		if(!$kblib->add_new_doctype($_REQUEST['newname'],$_REQUEST['newname_type']))
		{
			// the add failed
			$smarty->assign('message',"Failed to add DocType");
			break;
		}
	}
	
	# Reload this table because we've just changed it!
	$doctypes_table=$kblib->get_doctypes_table();
	$smarty->assign('available_doctypes',$doctypes_table);
}
// Category handling
elseif(isset($_REQUEST['cat_add1']))
{
	// adding a new category to the table
	
	// set the template up
	$smarty->assign('newcategory1',$_REQUEST['newcategory1']);
	
	if((isset($_REQUEST['newcategory1'])) && ($_REQUEST['newcategory1'] != ""))
	{
		// add a new category 1 item
		if(!$kblib->add_new_category($_REQUEST['newcategory1'],1))
		{
			// add failed
			$smarty->assign('message',"Failed to add new major category '".$_REQUEST['newcategory1']."'");
		}
		$category1=$kblib->get_categories(1);
		$smarty->assign_by_ref('category1',$category1);
	}
}
elseif(isset($_REQUEST['cat_add2']))
{
	// adding a new category to the table
	
	// set the template up
	$smarty->assign('newcategory2',$_REQUEST['newcategory2']);
	
	if((isset($_REQUEST['newcategory2'])) && ($_REQUEST['newcategory2'] != ""))
	{
		// add a new category 2 item
		if(!$kblib->add_new_category($_REQUEST['newcategory2'],2))
		{
			// add failed
			$smarty->assign('message',"Failed to add new sub category '".$_REQUEST['newcategory2']."'");
		}
		$category2=$kblib->get_categories(2);
		$smarty->assign_by_ref('category2',$category2);
	}
}
elseif(isset($_REQUEST['cat_edit1']))
{
	if((isset($_REQUEST['categoryid'])) && (isset($_REQUEST['editcategory1'])) && ($_REQUEST['editcategory1'] != ""))
	{
		// Looks like we're supposed to save something out...
		if(!$kblib->change_category_name($_REQUEST['categoryid'],$_REQUEST['editcategory1']))
		{
			// the change failed
			$smarty->assign('message',"Failed to change category name");
		}
		$category1=$kblib->get_categories(1);
		$smarty->assign_by_ref('category1',$category1);
	}
	
	// Now get the right stuff out for display
	
	$smarty->assign('operation_mode',"edit_category1");
	
	$catname=array("categoryname" => "");
	
	if(isset($_REQUEST['categoryid']))
	{
		$smarty->assign('categoryid',$_REQUEST['categoryid']);
		$catname=$kblib->get_category_by_id($_REQUEST['categoryid']);
	}
	elseif(isset($_REQUEST['category1']))
	{
		$smarty->assign('categoryid',$_REQUEST['category1']);
		$catname=$kblib->get_category_by_id($_REQUEST['category1']);
	}

	$smarty->assign('editcategory1',$catname['categoryname']);
}
elseif(isset($_REQUEST['cat_edit2']))
{
	if((isset($_REQUEST['categoryid'])) && (isset($_REQUEST['editcategory2'])) && ($_REQUEST['editcategory2'] != ""))
	{
		// Looks like we're supposed to save something out...
		if(!$kblib->change_category_name($_REQUEST['categoryid'],$_REQUEST['editcategory2']))
		{
			// the change failed
			$smarty->assign('message',"Failed to change category name");
		}
		$category2=$kblib->get_categories(2);
		$smarty->assign_by_ref('category2',$category2);
	}
	
	// Now get the right stuff out for display
	
	$smarty->assign('operation_mode',"edit_category2");
	
	$catname=array("categoryname" => "");
	
	if(isset($_REQUEST['categoryid']))
	{
		$smarty->assign('categoryid',$_REQUEST['categoryid']);
		$catname=$kblib->get_category_by_id($_REQUEST['categoryid']);
	}
	elseif(isset($_REQUEST['category2']))
	{
		$smarty->assign('categoryid',$_REQUEST['category2']);
		$catname=$kblib->get_category_by_id($_REQUEST['category2']);
	}

	$smarty->assign('editcategory2',$catname['categoryname']);

}
elseif(isset($_REQUEST['cat_delete1']))
{
	if(isset($_REQUEST['category1']))
	{
		$name=$kblib->delete_category($_REQUEST['category1']);
		if($name)
		{
			$smarty->assign('message',"Major category '$name' deleted");
			$category1=$kblib->get_categories(1);
			$smarty->assign_by_ref('category1',$category1);
		}
		else
		{
			// delete failed
			$smarty->assign('message',"Failed to delete category. Do documents of this category exist?");
		}
	}
}
elseif(isset($_REQUEST['cat_delete2']))
{
	if(isset($_REQUEST['category2']))
	{
		$name=$kblib->delete_category($_REQUEST['category2']);
		if($name)
		{
			$smarty->assign('message',"Sub category '$name' deleted");
			$category2=$kblib->get_categories(2);
			$smarty->assign_by_ref('category2',$category2);
		}
		else
		{
			// delete failed
			$smarty->assign('message',"Failed to delete category. Do documents of this category exist?");
		}
	}
}
elseif(isset($_REQUEST['categorise_article']))
{
	// User wants to categorise existing CMS articles
	$smarty->assign('operation_mode','categorise_article');
	
	// Before we continue, check to see if the user has selected a
	// document for categorisation.
	if((isset($_REQUEST['documentid'])) && (isset($_REQUEST['doctype'])) &&
		(isset($_REQUEST['category1'])) && (isset($_REQUEST['category2'])) )
	{
		// User has provided all necessary fields...
		$smarty->assign('message',"Thank you");
	}
	
	
	// To do this, we need to offer a selection of display names
	// (but only those that are of type "article"). If no display
	// names are available, then this feature must also be
	// unavailable.
	
	// step through doctypes_table and find "article" entries
	
	$table_out=array();
	foreach ($doctypes_table as $row)
	{
		if($row['doctype'] == "article")
		{
			$table_out[]=$row;
		}
	}
	$smarty->assign_by_ref('cat_doctypes',$table_out);
	
	// Now get the CMS documents list...
	// We use $tikilib to list them...
	$articles_list=$tikilib->list_articles(0,-1,'publishDate_desc','','','','');
	
	// Now, step through them all and just keep the ones that haven't been
	// categorised.
	// This isn't easy, because we're effectively working backwards up a
	// chain of data in the database.
	// The process is:
	// - Get all assignments with docId=articleId
	// - Step through them, checking the doctype to see if it's actually an article
	// - Discard anything we find like this, keep anything else (ie. the ones that arn't
	//   categorised)
	
	$smarty->assign('documents',$articles_list['data']);
	
}
elseif(isset($_REQUEST['categorise_faq']))
{
	// User wants to categorise existing Tiki FAQs
	$smarty->assign('operation_mode','categorise_faq');
	
	// To do this, we need to offer a selection of display names
	// (but only those that are of type "article"). If no display
	// names are available, then this feature must also be
	// unavailable.
	
	// step through doctypes_table and find "faq" entries
	
	$table_out=array();
	foreach ($doctypes_table as $row)
	{
		if($row['doctype'] == "faq")
		{
			$table_out[]=$row;
		}
	}
	$smarty->assign_by_ref('cat_doctypes',$table_out);	
	
	
}
elseif(isset($_REQUEST['categorise_wiki']))
{
	// User wants to categorise existing Wiki pages
	$smarty->assign('operation_mode','categorise_wiki');
	
	// To do this, we need to offer a selection of display names
	// (but only those that are of type "article"). If no display
	// names are available, then this feature must also be
	// unavailable.
	
	// step through doctypes_table and find "wiki" entries
	
	$table_out=array();
	foreach ($doctypes_table as $row)
	{
		if($row['doctype'] == "wiki")
		{
			$table_out[]=$row;
		}
	}
	$smarty->assign_by_ref('cat_doctypes',$table_out);	
	
	
	
	
}

$smarty->assign('mid','tiki-kb_admin.tpl');

$smarty->display("styles/$style_base/tiki.tpl");

?>