<?
require_once('tiki-setup.php');
require_once('lib/kb/kblib.php');


// if(submitted)
//  save doc, and set docid
// if(docid)
//  read doc and display
// else
//  burp


// Now check permissions to access this page
if((!isset($tiki_p_view_kb)) || ($tiki_p_view_kb != 'y')) {
  $smarty->assign('msg',tra("Permission denied you cannot view KB pages"));
  $smarty->display("styles/$style_base/error.tpl");
  die;  
}


$kblib = new KBLib($dbTiki,$tikilib);

$doctypes=$kblib->get_available_doctypes();
$smarty->assign('doctypes',$doctypes);

$cat1=$kblib->get_categories(1);
$smarty->assign_by_ref('cat1',$cat1);

$cat2=$kblib->get_categories(2);
$smarty->assign_by_ref('cat2',$cat2);


// First, see if the docId is specified. If it is, then read that
// document from the database and seed the data structures with it.
// Later stuff then uses this to populate editable fields.
// Alternatively, if the user's posted us a load of data, then save
// it out and use it to see the data structures for later as well.
// If we don't seed it, then later, the editable fields will be
// empty.

// start with empty data structures
$document=array();
$faq=array();
$attribs=array();


if((isset($_REQUEST['doctype_typeid'])) && ($_REQUEST['doctype_typeid'] != ""))
{
	// User has submitted a document to us
	
	// Check if the user has sufficient privileges
	// If the docID is set, then we're updating a document, otherwise we're creating
	if((isset($_REQUEST['docId'])) && ($_REQUEST['docId'] != ""))
	{
		// editing
		if((!isset($tiki_p_edit_kb)) || ($tiki_p_edit_kb != 'y')) {
		  $smarty->assign('msg',tra("Permission denied. You cannot edit KB pages"));
		  $smarty->display("styles/$style_base/error.tpl");
		  die;  
		}
	}
	else
	{
		if((!isset($tiki_p_create_kb)) || ($tiki_p_create_kb != 'y')) {
		  $smarty->assign('msg',tra("Permission denied. You cannot create KB pages"));
		  $smarty->display("styles/$style_base/error.tpl");
		  die;  
		}
	}
	
	// Check all the input is sensible
	$doctype_row=$kblib->get_doctype_by_id($_REQUEST['doctype_typeid']);
	if(!isset($doctype_row['doctype']))
	{
		$smarty->assign('msg',tra("Document could not be saved because of invalid doctype ID."));
		$smarty->display("styles/$style_base/error.tpl");
		die;
	}
	
	// Make sure the categories and such like are all sensible
	if((isset($_REQUEST['newcat1'])) && ($_REQUEST['newcat1'] != ""))
	{
		// user has specified a new category name
		if((!isset($tiki_p_cat_kb)) || ($tiki_p_cat_kb != 'y')) {
		  $smarty->assign('msg',tra("Permission denied. You cannot create KB categories"));
		  $smarty->display("styles/$style_base/error.tpl");
		  die;  
		}
		
		// User has permissions...
		$kblib->add_new_category($_REQUEST['newcat1'],1);
		
		$cat_row=$kblib->get_category_by_name($_REQUEST['newcat1'],1);
		$category1=$cat_row['categoryID'];

		$cat1=$kblib->get_categories(1);
		$smarty->assign_by_ref('cat1',$cat1);
	}
	else
	{
		// Since the user has not specified a new category, we
		// have to use the pull down one
		$category1=$kblib->sanitise_input($_REQUEST['cat1']);
	}
	if((isset($_REQUEST['newcat2'])) && ($_REQUEST['newcat2'] != ""))
	{
		// user has specified a new category name
		if((!isset($tiki_p_cat_kb)) || ($tiki_p_cat_kb != 'y')) {
		  $smarty->assign('msg',tra("Permission denied. You cannot create KB categories"));
		  $smarty->display("styles/$style_base/error.tpl");
		  die;  
		}
		
		// User has permissions...
		$kblib->add_new_category($_REQUEST['newcat2'],2);
		
		$cat_row=$kblib->get_category_by_name($_REQUEST['newcat2'],2);
		$category2=$cat_row['categoryID'];
		
		$cat2=$kblib->get_categories(2);
		$smarty->assign_by_ref('cat2',$cat2);
	}
	else
	{
		// Since the user has not specified a new category, we
		// have to use the pull down one
		$category2=$kblib->sanitise_input($_REQUEST['cat2']);
	}
	
	// by here, $doctype_row is setup, so is $category1 and $category2
	// Now, do the document specific part. This is essentially a write to the
	// appropriate database table.
	// We do the KB bit later (the bit where we fill in the assignment table)
	// but we only do that if this flag contains the document ID...
	$document_id=0;
	$wikiname="";
	
	switch($doctype_row['doctype'])
	{
		case 'article':
			// Wanna put this in later
			$smarty->assign('msg',tra("Document could not be saved because article save/edit is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'faq':
			// Wanna put this in later
			$smarty->assign('msg',tra("Document could not be saved because FAQ save/edit is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'wiki':
			// Wanna put this in later
			$smarty->assign('msg',tra("Document could not be saved because Wiki save/edit is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'kbdoc':
			if(!isset($_REQUEST['auth']))
				$_REQUEST['auth']='n';
			if((isset($_REQUEST['docId'])) && ($_REQUEST['docId'] != ""))
			{
				// editing, so update a specific document
				// Get the docID from the assignments. We might as well set $attribs
				// even though it'll get set again later
				$attribs=$kblib->get_assignment_row($_REQUEST['docId']);
				// Now update the document
				if($kblib->update_kb_document($attribs['docID'],$_REQUEST['title'],"user",$_REQUEST['description'],$_REQUEST['body'],$_REQUEST['auth']))
					$document_id=$attribs['docID'];
			}
			else
			{
				// create a new document
				$document_id=$kblib->add_new_kb_document($_REQUEST['title'],"user",$_REQUEST['description'],$_REQUEST['body'],$_REQUEST['auth']);
				if(!isset($document_id))
					$document_id=0;
			}
			break;
		case 'kbfaq':
			if($tiki_p_admin_faqs != 'y') {
				$smarty->assign('msg',tra("You dont have permission to use this feature"));
				$smarty->display("styles/$style_base/error.tpl");
				die;
			}
			if(isset($_REQUEST["canSuggest"])&&$_REQUEST["canSuggest"]=='on') {
				$canSuggest='y';
			} else {
				$canSuggest='n';
			}
			
			if((isset($_REQUEST['docId'])) && ($_REQUEST['docId'] != ""))
			{
				// editing an existing document
				$attribs=$kblib->get_assignment_row($_REQUEST['docId']);
				$fid = $kblib->replace_faq($attribs['docID'], $_REQUEST["title"], $_REQUEST["description"],$canSuggest);
				$document_id=$attribs['docID'];
			}
			else
			{
				$document_id = $kblib->replace_faq('', $_REQUEST["title"], $_REQUEST["description"],$canSuggest);
				if(!isset($document_id))
					$document_id=0;
			}
			
			// Now see if they're adding or editing a question
			if((isset($_REQUEST['question'])) && ($_REQUEST['question'] != ""))
			{
				// They've set a question, so add/replace/delete it...
				if((isset($_REQUEST['quId'])) && ($_REQUEST['quId'] != ""))
				{
					// Editing a question - replace it
					if($kblib->replace_faq_question($attribs['docID'],$_REQUEST['quId'], $_REQUEST['question'], $_REQUEST['answer']))
					{
						$smarty->assign('message',"Question edited in FAQ");
						$question_has_been_saved="yes";
					}
					else
					{
						$smarty->assign('message',"Failed to edit question in FAQ");
					}
				}
				else
				{
					// new question - add it...
					if($kblib->replace_faq_question($attribs['docID'],'', $_REQUEST['question'], $_REQUEST['answer']))
					{
						$smarty->assign('message',"Question added to FAQ");
						$question_has_been_saved="yes";
					}
					else
					{
						$smarty->assign('message',"Failed to add question to FAQ");
					}
				}
			}
			
			// these should be smarter than this in the attribs and document structures
			$smarty->assign('faqId',$document_id);
			$smarty->assign('title','$_REQUEST["title"]');
			$smarty->assign('description','$_REQUEST["description"]');
			$smarty->assign('canSuggest',$canSuggest);
		
			break;
		default:
			// Just in case...
			$smarty->assign('msg',tra("Document could not be saved because ".$doctype_row['doctype']." save/edit is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
	}
	
	if(($document_id != 0) || ($wikiname != ""))
	{
		if((isset($_REQUEST['docId'])) && ($_REQUEST['docId'] != ""))
		{
			// update the assignments table
			if($kblib->update_assignment($_REQUEST['docId'],$doctype_row['typeid'],$category1,$category2,$_REQUEST['keywords'],$document_id,$wikiname))
				$smarty->assign('docId',$_REQUEST['docId']);
		}
		else
		{
			// Save out the assignment table data
			$result=$kblib->add_new_assignment($doctype_row['typeid'],$category1,$category2,$_REQUEST['keywords'],$document_id,$wikiname);
			$_REQUEST['docId']=$result;
		}
		
	}
			

}


if((isset($_REQUEST['docId'])) && ($_REQUEST['docId'] != ""))
{
	// user has specified a document ID
	
	$smarty->assign('docId',$_REQUEST['docId']);
	
	// Check if the user has sufficient privileges
	if((!isset($tiki_p_edit_kb)) || ($tiki_p_edit_kb != 'y')) {
	  $smarty->assign('msg',tra("Permission denied. You cannot edit KB pages"));
	  $smarty->display("styles/$style_base/error.tpl");
	  die;  
	}
	
	$suggested = $kblib->list_suggested_questions(0,-1,'created_desc','');
	$smarty->assign_by_ref('suggested',$suggested["data"]);
	
	// Read the document from the database
	// Get the docID from the assignmentID (which the user calls "docId")
	if(!isset($attribs['docID']))
		$attribs=$kblib->get_assignment_row($_REQUEST['docId']);
	
	
	if((!isset($attribs['assignmentID'])) || (!isset($attribs['docID'])))
	{
		$smarty->assign('msg',tra("Document ".$_REQUEST['docId']." could not be read."));
		$smarty->display("styles/$style_base/error.tpl");
		die;
	}

	// Document read, all set to go

	// To get here, we must have done a load of work, but
	// ultimately, populated $document and $attribs with the details
	// of the document we've been working with.

	switch($attribs['doctype'])
	{
		case 'article':
			$smarty->assign('msg',tra("Article editing is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'faq':
			$smarty->assign('msg',tra("FAQ editing is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'wiki':
			$smarty->assign('msg',tra("Wiki editing is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
		case 'kbdoc':
			// Now get the actual document
			if(isset($attribs['docID']))
				$document=$kblib->get_kb_document($attribs['docID']);
			$smarty->assign_by_ref('document',$document);
			$smarty->assign_by_ref('attribs',$attribs);
			$smarty->assign('current_state',"edit");
			
			// legacy
			$smarty->assign('doctype',$attribs['doctype']);
			$smarty->assign('doctype_displayname',$attribs['displayname']);
			$smarty->assign('doctype_typeid',$attribs['doctype_typeid']);
			$smarty->assign('docId',$_REQUEST['docId']);
			break;
		case 'kbfaq':
		
		
			if((isset($_REQUEST['quId'])) && ($_REQUEST['quId'] != "") && (isset($_REQUEST['delete'])))
			{
				// want to delete the question
				$kblib->remove_faq_question($_REQUEST['quId']);
				$smarty->assign('message',"Question deleted from FAQ");
			}
		
			if(isset($attribs['docID']))
				$document=$kblib->get_kb_faq($attribs['docID']);
				
			if(isset($_REQUEST["find"])) {
			  $find = $_REQUEST["find"];  
			} else {
			  $find = ''; 
			}
			$smarty->assign('find',$find);
			
			$channels = $kblib->list_faq_questions($attribs['docID'],0,-1,'question_asc',$find);

			$smarty->assign_by_ref('channels',$channels["data"]);
			
			if((isset($_REQUEST['quId'])) && ($_REQUEST['quId'] != "") && (!isset($question_has_been_saved)))
			{
				// question specified, provide enough stuff to fill in the
				// form properly
				// Get the question out of the array
				foreach($channels['data'] as $item)
				{
					if($item['questionId'] == $_REQUEST['quId'])
					{
						$smarty->assign('question',$item['question']);
						$smarty->assign('answer',$item['answer']);
						$smarty->assign('quId',$_REQUEST['quId']);
					}
				}
			}
			
			
			$smarty->assign_by_ref('document',$document);
			$smarty->assign_by_ref('attribs',$attribs);
			$smarty->assign('current_state',"edit");
			
			break;

		default:
			$smarty->assign('msg',tra($attribs['doctype']." editing is not implemented."));
			$smarty->display("styles/$style_base/error.tpl");
			die;
			break;
	}
	
}
else
{
	// no docid - we wern't called with one, and we didn't get
	// so prompt to create a new doc, or otherwise tell the template
	// to show a blank document
	
	// Check if the user has sufficient privileges
	if((!isset($tiki_p_create_kb)) || ($tiki_p_create_kb != 'y')) {
	  $smarty->assign('msg',tra("Permission denied. You cannot create KB pages"));
	  $smarty->display("styles/$style_base/error.tpl");
	  die;  
	}

	if(isset($_REQUEST['doctype']))
	{

		// Find the doctype info in the database
		$details=$kblib->get_doctype_by_name($_REQUEST['doctype']);
		if(!isset($details['displayname']))
		{
			// Did not find this displayname in the database - barf!
			$smarty->assign('msg',tra("Could not find doctype ".$_REQUEST['doctype']));
			$smarty->display("styles/$style_base/error.tpl");
			die;  
		}

		$attribs=array();
		$attribs['displayname']=$details['displayname'];
		$attribs['doctype']=$details['doctype'];
		$attribs['doctype_typeid']=$details['typeid'];

		$smarty->assign_by_ref('attribs',$attribs);
		
		$smarty->assign('current_state',"edit");
	}
}


$smarty->assign('mid','tiki-kb_edit.tpl');

$smarty->display("styles/$style_base/tiki.tpl");


?>